<template>
    <span v-if="hasProfile" class="company-profile">
        <switch-edit-icon v-if="isProfileEditable || isExtraFieldsEditable" v-model="editMode" @input="discardChanges" class="edit-icon"/>
        <diff-table v-if="profileFields" v-model="profileFields" :diff-data="fieldsDiff" :id="editParamsPath.field" :editMode="editMode"
            :path="editParamsPath" :editableParams="editableParams" @edited="handleCompanyFields"/>
        <br/>
        <extra-fields-details v-model="profileExtraFields" :editMode="editMode" :editableParams="editableExtraParams" :diff-data="extraFieldsDiff"/>
    </span>
    <span v-else class="no_data">No company details</span>
</template>

<script>
import SwitchEditIcon from '@bloomio/spa-admin-common/components/switch-edit-icon';
import ExtraFieldsDetails from '@/components/ExtraFieldsDetails';
import DiffTable from '@/components/tables/DiffTable';
import { companyProfileEditParams, extraFieldsEditParams } from '@/constants/ui/details';
import { mapState } from 'vuex';

export default {
    components: {
        DiffTable,
        ExtraFieldsDetails,
        SwitchEditIcon,
    },
    props: {
        /** reset profile data */
        initData: {
            type: Object,
            required: false,
            default: () => {},
        },
        /** UI settings */
        config: {
            type: Object,
            required: false,
            default: () => {},
        },
    },
    created() {
        if (this.$store.getters.hasEditedProfileSections) {
            this.editMode = true;
        }
    },
    data() {
        return {
            editMode: false, // status of edit mode
        };
    },
    computed: {
        editParamsPath: () => ({ root: 'pending_profile', field: 'fields' }),
        isProfileEditable: vm => vm.$store.getters.isEditable(vm.editParamsPath.root, 'fields'),
        isExtraFieldsEditable: vm => vm.$store.getters.isEditable(vm.editParamsPath.root, 'extra_fields'),
        hasProfile: vm => vm.initData.pending && ((vm.profileFields && Object.keys(vm.profileFields).length)
            || (vm.profileExtraFields && vm.profileExtraFields.length)),
        editableParams: () => companyProfileEditParams,
        isPropInPublished: vm => key => vm.initData.published && vm.initData.published[key],
        editableExtraParams: () => extraFieldsEditParams,
        ...mapState({
            profileFields: state => state.editUser.profileFields,
            profileExtraFields: state => state.editUser.profileExtraFields,
        }),
        fieldsDiff: (vm) => {
            const fieldsDiff = { published: {}, pending: {}, labels: vm.config.subsections.fields.labels };
            if (vm.initData && vm.initData.pending) {
                Object.keys(fieldsDiff.labels).forEach((key) => {
                    fieldsDiff.pending[key] = vm.initData.pending.fields[key];
                    fieldsDiff.published[key] = vm.isPropInPublished('fields') ? vm.initData.published.fields[key] : '';
                });
            }
            return fieldsDiff;
        },
        extraFieldsDiff: vm => (Array.isArray(vm.initData.pending.extra_fields) ? vm.initData.pending.extra_fields.reduce((acc, obj, ind) => {
            acc.push({
                pending: { ...obj },
                published: vm.isPropInPublished('extra_fields') ? vm.initData.published.extra_fields[ind] : '',
                labels: vm.config.subsections.extra_fields.labels,
            });
            return acc;
        }, []) : []),
    },
    methods: {
        /** Force discard changes from external UIs */
        forceDiscardChanges() {
            this.editMode = false;
            this.discardChanges(false);
        },
        /**
         * Handler for discarding data changes
         * @param {Boolean} editFlag - edit mode status
         * */
        discardChanges(editFlag) {
            if (!editFlag && this.initData && this.initData.pending) {
                this.$store.commit('updateCompanyProfileFields', this.initData.pending);
                this.$store.commit('clearEditedFields', ['fields', 'extra_fields']);
                this.$store.commit('clearValidationMessage', { path: ['pending_profile'], id: 'fields' });
                this.$store.commit('clearValidationMessage', { path: ['pending_profile'], id: 'extra_fields' });
            }
        },
        /**
         * Update current Company Profile data
         * @param {Object} editData - options of the edited parameter
         * */
        handleCompanyFields(editData) {
            this.$store.commit('updatePendingProfileParam', editData);
            this.$store.commit('updateEditedFields', editData);
        },
    },
};
</script>

<style lang="stylus" scoped>
.edit-icon
    display: flex
    justify-content: flex-end
    margin: 0 6rem 1rem 0

</style>
